package de.fhdw.gaming.ipspiel22.vierGewinnt.domain.factory;

import java.util.ArrayList;
import java.util.List;
import java.util.ServiceLoader;

/**
 * Implements {@link VGStrategyFactoryProvider} by using the {@link ServiceLoader}.
 */
public final class VGDefaultStrategyFactoryProvider implements VGStrategyFactoryProvider {

    @Override
    public List<VGStrategyFactory> getStrategyFactories() {
        final ServiceLoader<VGStrategyFactory> services = ServiceLoader.load(VGStrategyFactory.class);
        final List<VGStrategyFactory> list = new ArrayList<>();
        services.iterator().forEachRemaining(list::add);
        return list;
    }

}
